﻿/**
* @description YJZ_JsBridge 云家政Hybird库
* @author zhanghuaiqing@yunjiazheng.com
*/


//Hybrid基本交互定义
window.YJZ_JsBridge=(function(){
    var _bridgePostMsg = function (url) {
        if ($.os.ios) {
            return;//window.location = url; ios则不再请求
        } else {
            var ifr = $('<iframe style="display: none;" src="' + url + '"/>');
            $('body').append(ifr);
            setTimeout(function () {
                ifr.remove();
            }, 1000)
        }
    };
    var _getHybridUrl = function (params) {
        var k, paramStr = '', url = params.scheme?params.scheme:'hybrid://';
        if(typeof params.url==="string"){
            url=params.url;
        }
        url += params.tagname + '?t=' + new Date().getTime(); //时间戳，防止url不起效
        if (params.posts) {
            paramStr = typeof params.posts == 'object' ? JSON.stringify(params.posts) : params.posts;
            url += '&param=' + encodeURIComponent(paramStr);
        }
        return url;
    };
    var _requestHybrid = function (params) {
        //生成唯一执行函数，执行后销毁
        var tt = (new Date().getTime());
        var t = 'hybrid_callback_' + tt;
        var tmpFn;
        //处理有回调的情况
        if (params.callback) {
            tmpFn = params.callback;
            params.posts.callback = t;
            window.YJZ_JsBridge.callbacks[t] = function (data) {
                tmpFn(data);
                delete window.YJZ_JsBridge.callbacks[t];
            }
        }
        //iOS请求
        if ($.os.ios){
            var func="app"+params.tagname.replace(/(\w)/,function(v){return v.toUpperCase()});
            if(typeof params.posts==="object"){
                
            }else{
                var _paramsArr=params.posts.split("://");
                var _posts=_paramsArr.length>1?_paramsArr[1]:_paramsArr[0];
                if(typeof tmpFn==="function"){
                    params.posts={
                        callback:t,
                        params:_posts
                    }
                }
            }
            console.log(func);
            console.log(JSON.stringify(params.posts));
            try{
                UlifeApp[func](params.posts);
            }
            catch(ex){
                confirm(JSON.stringify(ex));
            }
        }
        //android请求
        else{
            if(typeof params.posts==="string"){
                params={
                    url:params.posts,
                    posts:{
                        callback:t
                    }
                }
            }
            var posts=_getHybridUrl(params);
            console.log(posts);
            console.log(decodeURIComponent(posts));
            _bridgePostMsg(posts);
        }
    };

    var jsBridgeInterface={
        //打开页面
        openUrl:function(params){
            _requestHybrid(params);
        },
        //打电话
        callPhone:function(params){
            _requestHybrid(params);
        },
        //发短信
        smsPhone:function(params){
            _requestHybrid(params);
        },
        //摄像头
        setCamera:function(params){
            _requestHybrid(params);
        },
        //提示操作
        toast:function(params){
            _requestHybrid(params);
        },
        //弹窗
        prompt:function(params){
            _requestHybrid(params);
        },
        //推荐分享
        shareAction:function(params){
            params.scheme="share://";
            _requestHybrid(params);
        },
        //登录
        login:function(params){
            _requestHybrid(params);
        },
        //注销
        logout:function(params){
            _requestHybrid(params);
        }
    };

    var res={
        //获取版本信息，约定APP的navigator.userAgent版本包含版本信息：scheme/xx.xx.xx
        getHybridInfo :function () {
            var platform_version = {};
            var na = navigator.userAgent;
            var info = na.match(/scheme\/\d\.\d\.\d/);
            if (info && info[0]) {
                info = info[0].split('/');
                if (info && info.length == 2) {
                    platform_version.platform = info[0];
                    platform_version.version = info[1];
                }
            }
            return platform_version;
        },
        //请求
        invoke:function(func,params,callback,scheme){
            var _params={
                tagname:func,
                posts:params,
                scheme:scheme
            }
            if(typeof callback=="function"){
                _params.callback=callback;
            }
            if(typeof jsBridgeInterface[func]==="function"){
                jsBridgeInterface[func].call(this,_params);
            }
        },
        //回调容器
        callbacks:[]
    }

    return res;
})();